﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.Windows.PropertyGrid;

namespace PropertyGridSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
       
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            //PrintDialog printDialog = new PrintDialog();
           
            //if (printDialog.ShowDialog() == true)
            //{
            //    printDialog.PrintVisual(userControl, "UserControl");
            //}
         
           // var uc = new UserControl1();

            var printDialog = new PrintDialog();
            if (printDialog.ShowDialog() != true) return;

            var uc = new UserControl1();

            var size = new Size(printDialog.PrintableAreaWidth, printDialog.PrintableAreaHeight);

            var document = new FixedDocument();
            document.DocumentPaginator.PageSize = size;

            uc.Width = size.Width - (uc.Margin.Left + uc.Margin.Right);
            uc.Height = size.Height - (uc.Margin.Top + uc.Margin.Bottom);

            uc.Measure(size);
            uc.Arrange(new Rect(0, 0, size.Width, size.Height));
            uc.UpdateLayout();

            var page1 = new FixedPage();
            page1.Width = document.DocumentPaginator.PageSize.Width;
            page1.Height = document.DocumentPaginator.PageSize.Height;
            page1.Children.Add(uc);

            var page1Content = new PageContent();
            ((System.Windows.Markup.IAddChild)page1Content).AddChild(page1);
            document.Pages.Add(page1Content);

            printDialog.PrintDocument(document.DocumentPaginator, "Report");
        }
    }
}
